<template>
  <q-page>
    <div class="bg-image"></div>
    <!-- <example-component
      title="Example component"
      active
      :todos="todos"
      :meta="meta"
    ></example-component> -->

    <div class="row justify-evenly">
      <div class="col-12 col-sm-6 col-md-4 q-ma-md">
        <div class="row justify-center text-h5 q-ma-md">
          Vaccine slot notifier by&nbsp;
          <a
            class="text-black text-bold"
            href="https://rebhu.com"
            target="_blank"
            >Rebhu Computing</a
          >
        </div>
        <div class="row justify-center text-subtitle2 text-black">
          Any problems? Ping us&nbsp;
          <a class="text-black" href="https://twitter.com/RebhuComputing"
            >@RebhuComputing</a
          >
        </div>

        <div v-for="(request, index) in notifyRequests" :key="index">
          <request-form
            ref="form"
            class="q-pa-md q-ma-md bg-white border-circle shadow-2"
            v-bind:request.sync="notifyRequests[index]"
            :index="index"
            @removeNotifier="removeNotifierForm(index)"
          />
        </div>

        <div class="row justify-end q-ma-md q-gutter-sm">
          <q-btn
            push
            no-caps
            color="accent"
            label="Add more"
            v-if="notifyRequests.length < 3"
            @click="addNotifierForm"
          />
          <q-btn
            no-caps
            class="shadow-4"
            color="primary"
            label="Notify Me"
            :loading="processingRequests"
            @click="createRequests()"
          />
        </div>

        <div class="row justify-center q-mt-lg q-pa-md">
          <q-card class="full-width col-md-3 col-sm-4 col-6">
            <q-card-section>
              <div class="text-h6 text-center">
                How it works?
              </div>
              <!-- <q-img src="https://images.unsplash.com/photo-1608326389386-0305acbe600f" /> -->
            </q-card-section>

            <q-separator inset />

            <q-card-section>
              <q-list padding class="text-primary text-subtitle2">
                <q-item v-ripple>
                  <q-item-section avatar>
                    <q-icon name="mdi-map-marker" />
                  </q-item-section>

                  <q-item-section
                    >Enter your pincode(s) and select the desired age
                    group</q-item-section
                  >
                </q-item>

                <q-item v-ripple>
                  <q-item-section avatar>
                    <q-icon name="mdi-gesture-tap-button" />
                  </q-item-section>

                  <q-item-section
                    >Press 'Notify me' button and allow notification
                    permission</q-item-section
                  >
                </q-item>

                <q-item v-ripple>
                  <q-item-section avatar>
                    <q-icon name="mdi-needle" />
                  </q-item-section>

                  <q-item-section
                    >Get your vaccine shot and stay safe!!</q-item-section
                  >
                </q-item>
              </q-list>
            </q-card-section>

            <q-separator />

            <q-card-section>
              PS: We are not going to talk about data privacy. As we do not
              collect any data.
            </q-card-section>
          </q-card>

          <q-card class="full-width col-md-3 col-sm-4 col-6 q-mt-md">
            <q-list bordered padding>
              <q-item v-for="(product, index) in company" :key="index">
                <q-item-section top avatar>
                  <q-avatar rounded size="96px">
                    <img :src="require('assets/' + product.logo.toString())" />
                  </q-avatar>
                </q-item-section>

                <q-item-section>
                  <q-item-label class="text-h6">
                    <a :href="product.link" class="text-black">{{
                      product.name
                    }}</a>
                  </q-item-label>
                  <q-item-label caption>{{ product.motto }}</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>
      </div>
    </div>

    <q-dialog v-model="warningNotifyDialog" persistent>
      <q-card>
        <q-card-section class="row">
          <q-avatar
            icon="notifications_active"
            color="primary"
            text-color="white"
          />
          <div class="q-ml-sm col">
            <span class="text-bold text-subtitle1">
              Allow browser notification permission after submitting the form.
            </span>
            We cannot provide updates without notification permission.
          </div>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            flat
            label="Okay"
            color="primary"
            @click="warningNotifyDialog = false"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-dialog v-model="confirmNotifyDialog" persistent>
      <q-card>
        <q-card-section class="row">
          <q-avatar
            icon="notifications_active"
            color="primary"
            text-color="white"
          />
          <div class="q-ml-sm col">
            Please <span class="text-bold text-primary">allow</span> the asked
            permissions. We will send a test notification. If you
            <span class="text-bold text-primary">do not</span> receive a
            notification then clear browser data and register again.
          </div>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancel" color="primary" v-close-popup />
          <q-btn
            flat
            label="Got it"
            color="primary"
            @click="triggerNotificationRequests"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-return */
// import { Todo, Meta } from 'components/models';
// import ExampleComponent from 'components/CompositionComponent.vue';
import OWA from 'owa';
import RequestForm from 'components/RequestForm.vue';
import { defineComponent /*, ref */ } from '@vue/composition-api';

export default defineComponent({
  name: 'PageIndex',
  components: { /* ExampleComponent, */ RequestForm },
  // setup() {
  //   const todos = ref<Todo[]>([
  //     {
  //       id: 1,
  //       content: 'ct1'
  //     },
  //     {
  //       id: 2,
  //       content: 'ct2'
  //     },
  //     {
  //       id: 3,
  //       content: 'ct3'
  //     },
  //     {
  //       id: 4,
  //       content: 'ct4'
  //     },
  //     {
  //       id: 5,
  //       content: 'ct5'
  //     }
  //   ]);
  //   const meta = ref<Meta>({
  //     totalCount: 1200
  //   });
  //   return { todos, meta };
  // }
  data() {
    return {
      warningNotifyDialog: true,
      notifyRequestsLength: 0,
      notifyRequests: [],
      emptyRequest: {
        filter: [],
        pincode: null
      },
      processingRequests: false,
      confirmNotifyDialog: false,
      requestID: [],
      company: [
        {
          logo: 'rebhu-computing-icon.png',
          name: 'Rebhu Computing',
          motto: 'Making the world sustainable',
          link: 'https://rebhu.com'
        },
        {
          logo: 'hubscrib.in-icon.png',
          name: 'hubscrib',
          motto: 'Micropayments for the free(as in speech) internet',
          link: 'https://hubscrib.in'
        },
        {
          logo: 'logo.png',
          name: 'ROS Foundation',
          motto: 'Making the world open',
          link: 'https://rebhu.com'
        },
        {
          logo: 'rebhu.net-icon.png',
          name: 'Rebhu Net',
          motto: 'Hardware-less computing for today',
          link: 'https://rebhu.net'
        },
        {
          logo: 'solutions-by-rebhu-computing-logo.png',
          name: 'Rebhu Solution',
          motto: 'High fidelity, advanced quality Engineering as a Service',
          link: 'https://rebhu.com'
        },
        {
          logo: 'rebhu.social-icon.png',
          name: 'Rebhu Social',
          motto: 'Invite-only DAO for making the world more equitable',
          link: 'https://rebhu.com'
        }
      ],
      // int8VAPIDKey: null,
      initSubIterator: 0,
      maxInitSubIterator: 5
    };
  },

  mounted() {
    this.addNotifierForm();
    // this.getNotification();
    // this.storeVAPIDKey()
  },

  methods: {
    removeNotifierForm: function(index: number) {
      this.$delete(this.notifyRequests, index);
      this.notifyRequestsLength--;
    },

    addNotifierForm: function() {
      this.notifyRequests.push(this.emptyRequest);
      this.updateRequestFromChild(this.notifyRequestsLength - 1);
      this.notifyRequestsLength++;
    },

    updateRequestFromChild: function(index: number) {
      if (this.notifyRequestsLength !== 0) this.$refs.form[index].add();
    },

    updateNotifyRequestsFromChild: function() {
      for (let i = 0; i < this.notifyRequestsLength; i++) {
        this.updateRequestFromChild(i);
      }
    },

    getPayloadFromRequest: function(request: {
      filter: Array<number> | Array<string>;
      pincode: number;
    }) {
      return request.filter.map((item: { toString: () => string }) => {
        return {
          pincode: request.pincode,
          age_group: parseInt(item.toString())
        };
      });
    },

    getAllPayloadFromNotifyRequests: function() {
      this.updateNotifyRequestsFromChild();
      // console.log(this.notifyRequests);
      return this.notifyRequests.map(item => {
        let payloadFromRequest = this.getPayloadFromRequest(item);
        // console.log(...payloadFromRequest);
        return payloadFromRequest;
      });
    },

    createRequests: function() {
      this.processingRequests = true;
      const payloadArray = this.getAllPayloadFromNotifyRequests().flat();
      this.createPOSTRequestChain(
        payloadArray,
        payloadArray.length - 1,
        '/api/requests',
        null,
        this.createRequestsOnThen
        // this.createRequestsOnFinally
      )
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          this.createRequestsOnFinally();
        });
    },

    createRequestsOnThen: function(response) {
      // console.log('called createRequestsOnThen');
      this.requestID.push(response.data.request_id);
      // console.log(this.requestID);
    },

    createRequestsOnFinally: function() {
      // console.log('called finally');
      this.confirmNotifyDialog = true;
      // this.processingRequests = false;
    },

    createPOSTRequestChain: function(
      payloadArray: Array<unknown>,
      index: number,
      endpoint: string,
      httpPromises: unknown,
      onThen: (arg0: any) => void
      // onFinally: () => void
    ) {
      let httpChain = httpPromises;
      if (!httpPromises) {
        httpChain = this.createHTTPRequest(endpoint, payloadArray[index]);
      } else if (index >= 0) {
        httpChain = httpPromises.then((response: unknown) => {
          if (response) {
            onThen(response);
          }
          return this.createHTTPRequest(endpoint, payloadArray[index]);
        });
      }

      if (index >= 0) {
        // console.log('index >= 0 request#', index);
        return this.createPOSTRequestChain(
          payloadArray,
          index - 1,
          endpoint,
          httpChain,
          onThen
          // onFinally
        );
      } else if (index === -1) {
        // console.log('index', index);
        return httpPromises.then(response => {
          onThen(response);
          // console.log(response.data);
          return response;
        });
        // .catch(error => {
        //   console.log(error);
        // })
        // .finally(() => {
        //   onFinally();
        // });
      }
    },

    createHTTPRequest: function(endpoint, element) {
      // console.log('create HTTP request called');
      return this.$axios.post(endpoint, element);
    },

    triggerNotificationRequests: function() {
      this.checkBrowserNotificationSupport();
      this.confirmNotifyDialog = false;
    },

    notifyNotificationPermissionUpdate: function(msg: string, color: string) {
      this.$q.notify({
        message: msg,
        color: color,
        textColor: 'black',
        position: 'top-right'
      });
    },

    checkBrowserNotificationSupport: function() {
      if (!('Notification' in window)) {
        // console.log('This browser does not support notifications.');
        return false;
      } else {
        if (this.checkNotificationPromise()) {
          Notification.requestPermission().then(permission => {
            // console.log(permission)
            this.handlePermission(permission);
          });
        } else {
          Notification.requestPermission(permission => {
            // console.log(permission)
            this.handlePermission(permission);
          });
        }
      }
    },

    checkNotificationPromise: function() {
      try {
        Notification.requestPermission().then();
      } catch (error) {
        console.log(error);
        return false;
      }

      return true;
    },

    handlePermission: function(_permission) {
      // console.log(Notification.permission)
      const permissionFailed =
        'Notification request was cancelled. Please refresh the page, clear browser cache, and reset site-related permission.';
      const permissionSuccess =
        'We will keep you updated on latest vaccine centres and available slots';

      if (
        Notification.permission === 'denied' ||
        Notification.permission === 'default'
      ) {
        this.notifyNotificationPermissionUpdate(permissionFailed, 'warning');
      } else {
        this.notifyNotificationPermissionUpdate(permissionSuccess, 'accent');
        // this.createSimpleNotification();
        this.initSubscription();
      }
    },

    // storeVAPIDKey: function () {
    //   return this.$axios
    //   .get('/api/requests/subscription')
    //   .then((response: { data: { sub_token: string } }) => {
    //     // console.log(response.data);
    //     return response.data.sub_token;
    //   })
    //   .then(publicKey => {
    //     // console.log(publicKey);
    //     this.int8VAPIDKey =  this.urlBase64ToUint8Array(publicKey);
    //   })
    //   .catch((error) => {
    //     console.log(error)
    //   })
    // },

    initSubscription: function() {
      // console.log('init subscription');
      navigator.serviceWorker.ready
        .then(registration => {
          // console.log('service worker ready');
          return registration.pushManager
            .getSubscription()
            .then(subscription => {
              // console.log(subscription);
              if (subscription) return subscription;

              return this.$axios
                .get('/api/requests/subscription')
                .then((response: { data: { sub_token: string } }) => {
                  // console.log(response.data);
                  return response.data.sub_token;
                })
                .then(publicKey => {
                  // console.log(publicKey);
                  return this.urlBase64ToUint8Array(publicKey);
                })
                .then(convertedVAPIDKey => {
                  // console.log(convertedVAPIDKey);
                  return registration.pushManager.subscribe({
                    userVisibleOnly: true,
                    applicationServerKey: convertedVAPIDKey
                  });
                });
              // .then(subscription => {
              //   console.log(subscription);

              //   return this.requestID.map(item => {
              //     return this.$axios.post('/api/requests/subscription', {
              //       sub_token: JSON.stringify(subscription),
              //       request_id: item
              //     });
              //   });
              // })
              // .then(() => {
              //   return registration.pushManager.getSubscription();
              // })
            })
            .then(subscription => {
              if (
                subscription === null &&
                this.initSubIterator < this.maxInitSubIterator
              ) {
                this.initSubscription();
                this.initSubIterator++;
                throw Error('Subscription is null')
              } else {
                this.processingRequests = false;
              }
              // console.log(subscription);

              // TODO: Use the recursive function define above to improve this array of promises
              const subscriptionPostsPayload = this.requestID.map(item => {
                return {
                  sub_token: JSON.stringify(subscription),
                  request_id: item
                };
              });

              const subscriptionPOST = this.createPOSTRequestChain(
                subscriptionPostsPayload,
                subscriptionPostsPayload.length - 1,
                '/api/requests/subscription',
                null,
                () => void 0
                // this.pushWelcomeNotification(subscriptionPostsPayload[0])
              );

              // this.requestID = [];

              // console.log(subscriptionPOST);
              return {
                subPOST: subscriptionPOST,
                pushPayload: subscriptionPostsPayload[0]
              };
            });
          // .then(() => {
          //   return registration.pushManager.getSubscription();
          // })
          // .catch((error) => {
          //   console.log(error);
          // });
        })
        .then(subData => {
          this.requestID = [];
          this.pushWelcomeNotification(subData.pushPayload);
        })
        .catch(error => {
          console.log(error);
        });
    },

    urlBase64ToUint8Array: function(base64String) {
      var padding = '='.repeat((4 - (base64String.length % 4)) % 4);
      var base64 = (base64String + padding)
        .replace(/\-/g, '+')
        .replace(/_/g, '/');

      var rawData = window.atob(base64);
      var outputArray = new Uint8Array(rawData.length);

      for (var i = 0; i < rawData.length; ++i) {
        outputArray[i] = rawData.charCodeAt(i);
      }
      return outputArray;
    },

    pushWelcomeNotification: function(subscriptionPayload) {
      const payload = {
        sub_token: subscriptionPayload.sub_token,
        request_id: subscriptionPayload.request_id,
        text:
          'Welcome to GetCovaxIn. We will notify you about vaccine slot availability. Click to know more about auto-booking for vaccine slots.'
      };

      this.$axios
        .post('/api/requests/push', payload)
        .then(_response => {
          // console.log(response);
        })
        .catch(error => {
          console.log(error);
        });
    }
  }
});
</script>
